{
Graph V 0.95 - component for Delphi.

Graph is a component for Delphi, written in the Delphi 4 IDE.
What about this component and Delphi's versions ?

Delphi 1 : not supported without changes in code
Delphi 2 : certainely works but not tested
Delphi 3 : tested, OK
Delphi 4 : tested, OK

------------------------------------------------------------
Description
------------------------------------------------------------
This component is designed to ...


------------------------------------------------------------
Actually supported functions
------------------------------------------------------------
...

------------------------------------------------------------
Actually no supported functions (i work on it for next release)
------------------------------------------------------------
...

------------------------------------------------------------
Distribution and copyrights
------------------------------------------------------------
Released to public domain.

Thanks to all peoples who freely distribute their works (sometimes
hardly obtained).

Je sais, j'aurais pu joindre ce code source d'une explication
en francais !


------------------------------------------------------------
Any suggestions, comments, or bugs report
------------------------------------------------------------
MALLARD Remy
25 rue de Provence
78310 MAUREPAS
FRANCE

E-Mail: remy.mallard@cetec.tdf.fr


------------------------------------------------------------
Component History
------------------------------------------------------------
Rev 1 : 03/04/1999
Version : 0.95

}


unit rmGraph;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,  ExtCtrls, Clipbrd;

type
  TGridType = (gtNone, gtVertical, gtHorizontal, gtBoth);
  TValuePosition = (vpPixels, vpFullWidth);
  TTracesType = (Trace1, Trace2, Trace3, Trace4, Trace5, Trace6, Trace7, Trace8);
  TTextType = (stLeft, stRight, stBottom, stTop);
  TScaleText = set of TTextType;
  TTraces = set of TTracesType;

  TrmGraph = class(TGraphicControl)
  private
    FGridType: TGridType;
    FCTL3D: boolean;
    FShowOver: boolean;
    FValuePosition: TValuePosition;
    FBmpBuffer: TBitmap;
    FBGColor: TColor;
    FBorder: boolean;
    FGraphColor: TColor;
    FGridColor: TColor;
    FTrace1Color, FTrace2Color, FTrace3Color, FTrace4Color,
    FTrace5Color, FTrace6Color, FTrace7Color, FTrace8Color: TColor;
    FLeftMargin, FRightMargin, FTopMargin, FBottomMargin: integer;
    FHorzMinVal, FVertMinVal: single;
    FHorzMaxVal, FVertMaxVal: single;
    FHorzUnit, FVertUnit: string;
    FHorzDecNum, FVertDecNum: integer;
    FHorzDiv, FVertDiv: integer;
    FScaleText: TScaleText;
    FTraces: TTraces;
    FTextColor: TColor;
    FTextSize: integer;
    FMaxItems: integer;
    procedure SetGridType(value: TGridType);
    procedure SetCTL3D(value: boolean);
    procedure SetShowOver(value: boolean);
    procedure SetValuePosition(value: TValuePosition);
    procedure SetValues(value: TStringList);
    procedure SetBGColor(value: TColor);
    procedure SetBorder(value: boolean);
    procedure SetGraphColor(value: TColor);
    procedure SetGridColor(value: TColor);
    procedure SetTrace1Color(value: TColor);
    procedure SetTrace2Color(value: TColor);
    procedure SetTrace3Color(value: TColor);
    procedure SetTrace4Color(value: TColor);
    procedure SetTrace5Color(value: TColor);
    procedure SetTrace6Color(value: TColor);
    procedure SetTrace7Color(value: TColor);
    procedure SetTrace8Color(value: TColor);
    procedure SetLeftMargin(value: integer);
    procedure SetRightMargin(value: integer);
    procedure SetTopMargin(value: integer);
    procedure SetBottomMargin(value: integer);
    procedure SetHorzMinVal(value: single);
    procedure SetHorzMaxVal(value: single);
    procedure SetHorzUnit(value: string);
    procedure SetHorzDecNum(value: integer);
    procedure SetHorzDiv(value: integer);
    procedure SetVertMinVal(value: single);
    procedure SetVertMaxVal(value: single);
    procedure SetVertUnit(value: string);
    procedure SetVertDecNum(value: integer);
    procedure SetVertDiv(value: integer);
    procedure SetScaleText(value: TScaleText);
    procedure SetTraces(value: TTraces);
    procedure SetTextColor(value: TColor);
    procedure SetTextSize(value: integer);
    procedure SetMaxItems(value: integer);
  protected
    procedure Paint; override;
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;
    procedure UpdateBmpBuffer;
  public
    constructor Create(anOwner:TComponent); override;
    destructor Destroy; override;
    procedure Free;
  published
    Values: TStringList;
    property GridType: TGridType read FGridType write SetGridType default gtBoth;
    property ValuePosition: TValuePosition read FValuePosition write SetValuePosition;
    // property Values: TStringList read FValues write SetValues;
    property BGColor: TColor read FBGColor write SetBGColor default clGray;
    property CTL3D: boolean read FCTL3D write SetCTL3D default true;
    property ShowOver: boolean read FShowOver write SetShowOver default true;
    property Border: boolean read FBorder write SetBorder default true;
    property GraphColor: TColor read FGraphColor write SetGraphColor default clBlack;
    property GridColor: TColor read FGridColor write SetGridColor default clGreen;
    property Trace1Color: TColor read FTrace1Color write SetTrace1Color;
    property Trace2Color: TColor read FTrace2Color write SetTrace2Color;
    property Trace3Color: TColor read FTrace3Color write SetTrace3Color;
    property Trace4Color: TColor read FTrace4Color write SetTrace4Color;
    property Trace5Color: TColor read FTrace5Color write SetTrace5Color;
    property Trace6Color: TColor read FTrace6Color write SetTrace6Color;
    property Trace7Color: TColor read FTrace7Color write SetTrace7Color;
    property Trace8Color: TColor read FTrace8Color write SetTrace8Color;
    property LeftMargin: integer read FLeftMargin write SetLeftMargin;
    property RightMargin: integer read FRightMargin write SetRightMargin;
    property TopMargin: integer read FTopMargin write SetTopMargin;
    property BottomMargin: integer read FBottomMargin write SetBottomMargin;
    property HorzMinVal: single read FHorzMinVal write SetHorzMinVal;
    property HorzMaxVal: single read FHorzMaxVal write SetHorzMaxVal;
    property HorzUnit: string read FHorzUnit write SetHorzUnit;
    property HorzDiv: integer read FHorzDiv write SetHorzDiv;
    property HorzDecNum: integer read FHorzDecNum write SetHorzDecNum;
    property VertMinVal: single read FVertMinVal write SetVertMinVal;
    property VertMaxVal: single read FVertMaxVal write SetVertMaxVal;
    property VertUnit: string read FVertUnit write SetVertUnit;
    property VertDecNum: integer read FVertDecNum write SetVertDecNum;
    property VertDiv: integer read FVertDiv write SetVertDiv;
    property ScaleText: TScaleText read FScaleText write SetScaleText;
    property Traces: TTraces read FTraces write SetTraces;
    property TextColor: TColor read FTextColor write SetTextColor;
    property TextSize: integer read FTextSize write SetTextSize;
    property MaxItems: integer read FMaxItems write SetMaxItems;
    procedure SaveGraphToFile(sFile: TFileName);
    {
    procedure CopyGraphToClipboard;
    }
    procedure Clear;
    function AddValues(s: string; refresh: boolean): integer;
    function DeleteValues(i: integer; refresh: boolean): integer;
    { Standard properties }
    property Align;
    property Height;
    property Width;
    { Standard events }
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnClick;
    property OnDblClick;
  end;

  procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('OptoElec', [TrmGraph]);
end;

function r2s(dec: integer; r: real): string;
var
  s: string;
begin
  str(r:0:dec, s);
  result := s;
end;

function s2r(s: string): real;
var
  r: real;
  u: integer;
begin
  val(s, r, u);
  result := r;
end;

constructor TrmGraph.Create(anOwner:TComponent);
begin
  Inherited Create(anOwner);
  FBmpBuffer := TBitmap.Create;
  Values := TStringList.Create;
  FBorder := true;
  FCTL3D := true;
  FShowOver := true;
  FBGColor := clSilver;
  FGraphColor := clBlack;
  FGridColor := clGreen;
  FTrace1Color := clLime;
  FTrace2Color := clRed;
  FTrace3Color := clAqua;
  FTrace4Color := clYellow;
  FTrace5Color := clFuchsia;
  FTrace6Color := clBlue;
  FTrace7Color := clGreen;
  FTrace8Color := clSilver;
  Height := 305;
  Width := 433;
  FGridType := gtBoth;
  FValuePosition := vpPixels;
  FLeftMargin := 45;
  FRightMargin := 4;
  FTopMargin := 4;
  FBottomMargin := 20;
  FHorzMinVal := 0;
  FHorzMaxVal := 100;
  FHorzUnit := 's';
  FHorzDecNum := 0;
  FHorzDiv := 10;
  FVertMinVal := 0;
  FVertMaxVal := 55;
  FVertUnit := 'C';
  FVertDecNum := 1;
  FVertDiv := 10;
  FScaleText := [stLeft, stBottom];
  FTraces := [Trace1, Trace2, Trace3, Trace4];
  FTextColor := clBlue;
  FTextSize := 8;
  FMaxItems := 0;
end;

destructor TrmGraph.Destroy;
begin
  If FBmpBuffer <> NIL then FBmpBuffer.free;
  if Values <> nil then Values.Free;
  Inherited Destroy;
end;

procedure TrmGraph.Free;
begin
  FBmpBuffer.Free;
  Values.free;
  Inherited Free;
end;

procedure TrmGraph.SetBounds(aLeft, aTop, aWidth, aHeight: Integer);
begin
  Inherited ;
  If FBmpBuffer <> NIL then begin
    FBmpBuffer.Destroy;
    FBmpBuffer := TBitmap.Create;
    FBmpBuffer.Height := aHeight;
    FBmpBuffer.Width := aWidth;
  end;
end;

procedure TrmGraph.UpdateBmpBuffer;
var
  i, j: integer;
  val: real;
  sep: integer;
  s: string;
  HPos, VPos: integer;
  GraphHeight, GraphWidth: integer;
  ValuesTmp: TStringList;
  Empty: boolean;
  UpOver, DownOver: boolean;
begin
  DownOver := false;
  UpOver := false;
  try
    ValuesTmp := TStringList.Create;

  With FBmpBuffer.Canvas do begin
    GraphWidth := width - FLeftMargin - FRightMargin;
    GraphHeight := height - FTopMargin - FBottomMargin;

    // backGround
    Brush.Color := FBGColor;
    if FBorder then Pen.Color := clBlack else Pen.Color := FBGColor;
    Rectangle(0, 0, width, height);

    // graph BackGround
    Brush.Color := FGraphColor;
    Pen.Color := FGraphColor;
    Rectangle(FLeftMargin, FTopMargin, width - FRightMargin, Height - bottomMargin);

    // 3D Effect
    if FCTL3D then begin
      Pen.Color := clGray;
      moveTo(leftMargin - 1, TopMargin - 1);
      lineTo(leftMargin - 1, TopMargin + graphHeight);
      moveTo(leftMargin - 1, TopMargin - 1);
      lineTo(leftMargin + graphWidth, TopMargin - 1);
      Pen.Color := clWhite;
      moveTo(leftMargin + graphWidth, TopMargin - 1);
      lineTo(leftMargin + graphWidth, TopMargin + graphHeight + 1);
      moveTo(leftMargin - 1, TopMargin + graphHeight);
      lineTo(leftMargin + graphWidth, TopMargin + graphHeight);
    end;

    // grid
    if (FGridType = gtHorizontal) or (FGridType = gtBoth) then begin
      Pen.Color := FGridColor;
      for i := 1 to FHorzDiv - 1 do begin
        HPos := FLeftMargin + trunc((i * GraphWidth) / FHorzDiv);
        MoveTo(HPos, FTopMargin);
        LineTo(HPos, Height - FBottomMargin);
      end;
    end;
    if (FGridType = gtVertical) or (FGridType = gtBoth) then begin
      Pen.Color := FGridColor;
      for i := 1 to FVertDiv - 1 do begin
        VPos := FTopMargin + trunc((i * GraphHeight) / FVertDiv);
        MoveTo(FLeftMargin, VPos);
        LineTo(width - FRightMargin, VPos);
      end;
    end;

    // left, right, top and bottom scale
    if (stLeft in FScaleText) or (stRight in FScaleText) then begin
      brush.Color := FBGColor;
      font.Name := 'Arial';
      font.Color := FTextColor;
      font.Size := FTextSize;
      for i := 0 to FVertDiv do begin
        val := FVertMaxVal - ((FVertMaxVal - FVertMinVal) / FVertDiv) * i;
        s := r2s(FVertDecNum, val) + FVertUnit;
        if i = 0 then
          VPos := FTopMargin
        else if i = FVertDiv then
          VPos := FTopMargin + GraphHeight - textHeight(s) + 2
        else
          VPos := FTopMargin + trunc((i * GraphHeight) / FVertDiv) - (textHeight(s) div 2);
        if (stLeft in FScaleText) then
          textOut(FLeftMargin - 4 - textWidth(s), VPos, s);
        if (stRight in FScaleText) then
          textOut(FLeftMargin + graphWidth + 4, VPos, s);
      end;
    end;
    if (stTop in FScaleText) or (stBottom in FScaleText) then begin
      brush.Color := FBGColor;
      font.Name := 'Arial';
      font.Color := FTextColor;
      font.Size := FTextSize;
      for i := 0 to FHorzDiv do begin
        if (i = 0) or (i = FHorzDiv) then begin
          val := FHorzMinVal + ((FHorzMaxVal - FHorzMinVal) / FHorzDiv) * i;
          s := r2s(FHorzDecNum, val);
        end else begin
          val := FHorzMinVal + ((FHorzMaxVal - FHorzMinVal) / FHorzDiv) * i;
          s := r2s(FHorzDecNum, val) + FHorzUnit;
        end;
        if i = 0 then
          HPos := FLeftMargin - 2
        else if i = FHorzDiv then
          HPos := FLeftMargin + GraphWidth - textWidth(s)
        else
          HPos := FLeftMargin + trunc((i * GraphWidth) / FHorzDiv) - (textWidth(s) div 2);
        if (stTop in FScaleText) then
          textOut(HPos, FTopMargin - 4 - textHeight(s), s);
        if (stBottom in FScaleText) then
          textOut(HPos, FTopMargin + graphHeight + 4, s);
      end;
    end;

    // trace only in conception
    if csDesigning in ComponentState then begin
      brush.Color := GraphColor;
      font.size := FTextSize;

      // trace 1
      if Trace1 in FTraces then begin
        pen.Color := Trace1Color;
        font.Color := Trace1Color;
        moveTo(FLeftMargin, FTopMargin + (graphHeight div 10) * 1);
        lineTo(FLeftMargin + GraphWidth, FTopMargin + (graphHeight div 10) * 1);
        s := 'Trace 1 - Conception';
        textOut(FLeftMargin + 5, FTopMargin + (graphHeight div 10) * 1 - textHeight(s) - 2, s);
      end;

      // trace 2
      if Trace2 in FTraces then begin
        pen.Color := Trace2Color;
        font.Color := Trace2Color;
        moveTo(FLeftMargin, FTopMargin + (graphHeight div 10) * 2);
        lineTo(FLeftMargin + GraphWidth, FTopMargin + (graphHeight div 10) * 2);
        s := 'Trace 2 - Conception';
        textOut(FLeftMargin + 5, FTopMargin + (graphHeight div 10) * 2 - textHeight(s) - 2, s);
      end;

      // trace 3
      if Trace3 in FTraces then begin
        pen.Color := Trace3Color;
        font.Color := Trace3Color;
        moveTo(FLeftMargin, FTopMargin + (graphHeight div 10) * 3);
        lineTo(FLeftMargin + GraphWidth, FTopMargin + (graphHeight div 10) * 3);
        s := 'Trace 3 - Conception';
        textOut(FLeftMargin + 5, FTopMargin + (graphHeight div 10) * 3 - textHeight(s) - 2, s);
      end;

      // trace 4
      if Trace4 in FTraces then begin
        pen.Color := Trace4Color;
        font.Color := Trace4Color;
        moveTo(FLeftMargin, FTopMargin + (graphHeight div 10) * 4);
        lineTo(FLeftMargin + GraphWidth, FTopMargin + (graphHeight div 10) * 4);
        s := 'Trace 4 - Conception';
        textOut(FLeftMargin + 5, FTopMargin + (graphHeight div 10) * 4 - textHeight(s) - 2, s);
      end;

      // trace 5
      if Trace5 in FTraces then begin
        pen.Color := Trace5Color;
        font.Color := Trace5Color;
        moveTo(FLeftMargin, FTopMargin + (graphHeight div 10) * 5);
        lineTo(FLeftMargin + GraphWidth, FTopMargin + (graphHeight div 10) * 5);
        s := 'Trace 5 - Conception';
        textOut(FLeftMargin + 5, FTopMargin + (graphHeight div 10) * 5 - textHeight(s) - 2, s);
      end;

      // trace 6
      if Trace6 in FTraces then begin
        pen.Color := Trace6Color;
        font.Color := Trace6Color;
        moveTo(FLeftMargin, FTopMargin + (graphHeight div 10) * 6);
        lineTo(FLeftMargin + GraphWidth, FTopMargin + (graphHeight div 10) * 6);
        s := 'Trace 6 - Conception';
        textOut(FLeftMargin + 5, FTopMargin + (graphHeight div 10) * 6 - textHeight(s) - 2, s);
      end;

      // trace 7
      if Trace7 in FTraces then begin
        pen.Color := Trace7Color;
        font.Color := Trace7Color;
        moveTo(FLeftMargin, FTopMargin + (graphHeight div 10) * 7);
        lineTo(FLeftMargin + GraphWidth, FTopMargin + (graphHeight div 10) * 7);
        s := 'Trace 7 - Conception';
        textOut(FLeftMargin + 5, FTopMargin + (graphHeight div 10) * 7 - textHeight(s) - 2, s);
      end;

      // trace 8
      if Trace8 in FTraces then begin
        pen.Color := Trace8Color;
        font.Color := Trace8Color;
        moveTo(FLeftMargin, FTopMargin + (graphHeight div 10) * 8);
        lineTo(FLeftMargin + GraphWidth, FTopMargin + (graphHeight div 10) * 8);
        s := 'Trace 8 - Conception';
        textOut(FLeftMargin + 5, FTopMargin + (graphHeight div 10) * 8 - textHeight(s) - 2, s);
      end;

    end;

    // decode values in StringList Values...
    if Values.Count > 0 then begin
      ValuesTmp.Assign(Values);
      empty := false;
      for i := 1 to 8 do begin
        if empty then break;
        for j := 0 to ValuesTmp.Count - 1 do begin
          s := ValuesTmp[j];
          case i of
            1 : Pen.Color := FTrace1Color;
            2 : Pen.Color := FTrace2Color;
            3 : Pen.Color := FTrace3Color;
            4 : Pen.Color := FTrace4Color;
            5 : Pen.Color := FTrace5Color;
            6 : Pen.Color := FTrace6Color;
            7 : Pen.Color := FTrace7Color;
            8 : Pen.Color := FTrace8Color;
          end;
          sep := pos(';', s);
          if (sep = 0) and (s = '') then begin
            Empty := true;
            break;
          end;
          if sep > 0 then begin
            val := s2r(copy(s, 1, sep - 1));
            delete(s, 1, sep);
          end else begin
            val := s2r(s);
            s := '';
          end;
          ValuesTmp[j] := s;
          // if (val > FVertMaxVal) or (val < FVertMinVal) then continue;

          if (Trace1 in FTraces) and (i = 1)
          or (Trace2 in FTraces) and (i = 2)
          or (Trace3 in FTraces) and (i = 3)
          or (Trace4 in FTraces) and (i = 4)
          or (Trace5 in FTraces) and (i = 5)
          or (Trace6 in FTraces) and (i = 6)
          or (Trace7 in FTraces) and (i = 7)
          or (Trace8 in FTraces) and (i = 8)
          then begin

            // calculate horizontal position
            if FValuePosition = vpPixels then begin
              if j > GraphWidth then break;
              HPos := FLeftMargin + j;
            end else if FValuePosition = vpFullWidth then begin
              if j < 2 then
                HPos := FLeftMargin
              else
                HPos := FLeftMargin + trunc((GraphWidth * j) / (Values.Count - 1));
            end;

            // calculate vertical position
            VPos := FTopMargin + trunc(((FVertMaxVal - val) * GraphHeight) / (FVertMaxVal - FVertMinVal));
            if VPos > (FTopMargin + graphHeight - 1) then begin
              VPos := FTopMargin + graphHeight - 1;
              DownOver := true;
            end;
            if VPos < FTopMargin then begin
              VPos := FTopMargin;
              UpOver := true;
            end;

            // draw line
            if j = 0 then MoveTo(HPos, VPos);
            lineTo(HPos, VPos);
          end;

        end;
      end;
      // Over ?
      if FShowOver and (UpOver or (csDesigning in componentState)) then begin
        pen.color := clRed;
        brush.color := clRed;
        Polygon([Point(FLeftMargin + graphWidth - 8, FTopMargin + 4),
                  Point(FLeftMargin + graphWidth - 4, FTopMargin + 8),
                  Point(FLeftMargin + graphWidth - 12, FTopMargin + 8)]);
      end;
      if FShowOver and (DownOver or (csDesigning in componentState)) then begin
        pen.color := clRed;
        brush.color := clRed;
        Polygon([Point(FLeftMargin + graphWidth - 8, FTopMargin + 14),
                  Point(FLeftMargin + graphWidth - 4, FTopMargin + 10),
                  Point(FLeftMargin + graphWidth - 12, FTopMargin + 10)]);
      end;
    end;
  end;
  finally
    valuesTmp.Free;
  end;
end;

procedure TrmGraph.Paint;
begin
  try
    UpdateBmpBuffer;
  except
  end;
  try
    Canvas.Draw(0, 0, FBmpBuffer);
  except
  end;
end;

procedure TrmGraph.SaveGraphToFile(sFile: TFileName);
begin
  if FBmpBuffer <> nil then begin
    try
      FBmpBuffer.SaveToFile(sFile);
    except
    end;
  end;
end;

{
procedure TrmGraph.CopyGraphToClipboard;
begin
  if FBmpBuffer <> nil then begin
    try
      showMessage('Sorry, "CopyGraphToClipboard" procedure not implemented.');
    except
    end;
  end;
end;
}

procedure TrmGraph.SetValuePosition(value: TValuePosition);
begin
  if value <> FValuePosition then
  begin
    FValuePosition := value;
    Paint;
  end;
end;

procedure TrmGraph.SetValues(value: TStringList);
begin
  if value <> Values then
  begin
    Values := value;
    Paint;
  end;
end;

procedure TrmGraph.SetBGColor(value: TColor);
begin
  if value <> FBGColor then
  begin
    FBGColor := value;
    Paint;
  end;
end;

procedure TrmGraph.SetBorder(value: boolean);
begin
  if value <> FBorder then
  begin
    FBorder := value;
    Paint;
  end;
end;

procedure TrmGraph.SetCTL3D(value: boolean);
begin
  if value <> FCTL3D then
  begin
    FCTL3D := value;
    Paint;
  end;
end;

procedure TrmGraph.SetShowOver(value: boolean);
begin
  if value <> FShowOver then
  begin
    FShowOver := value;
    Paint;
  end;
end;

procedure TrmGraph.SetGraphColor(value: TColor);
begin
  if value <> FGraphColor then
  begin
    FGraphColor := value;
    Paint;
  end;
end;

procedure TrmGraph.SetGridColor(value: TColor);
begin
  if value <> FGridColor then
  begin
    FGridColor := value;
    Paint;
  end;
end;

procedure TrmGraph.SetTrace1Color(value: TColor);
begin
  if value <> FTrace1Color then
  begin
    FTrace1Color := value;
    Paint;
  end;
end;

procedure TrmGraph.SetTrace2Color(value: TColor);
begin
  if value <> FTrace2Color then
  begin
    FTrace2Color := value;
    Paint;
  end;
end;

procedure TrmGraph.SetTrace3Color(value: TColor);
begin
  if value <> FTrace3Color then
  begin
    FTrace3Color := value;
    Paint;
  end;
end;

procedure TrmGraph.SetTrace4Color(value: TColor);
begin
  if value <> FTrace4Color then
  begin
    FTrace4Color := value;
    Paint;
  end;
end;

procedure TrmGraph.SetTrace5Color(value: TColor);
begin
  if value <> FTrace5Color then
  begin
    FTrace5Color := value;
    Paint;
  end;
end;

procedure TrmGraph.SetTrace6Color(value: TColor);
begin
  if value <> FTrace6Color then
  begin
    FTrace6Color := value;
    Paint;
  end;
end;

procedure TrmGraph.SetTrace7Color(value: TColor);
begin
  if value <> FTrace7Color then
  begin
    FTrace7Color := value;
    Paint;
  end;
end;

procedure TrmGraph.SetTrace8Color(value: TColor);
begin
  if value <> FTrace8Color then
  begin
    FTrace8Color := value;
    Paint;
  end;
end;

procedure TrmGraph.SetGridType(value: TGridType);
begin
  if value <> FGridType then
  begin
    FGridType := value;
    Paint;
  end;
end;

procedure TrmGraph.SetLeftMargin(value: integer);
begin
  if value <> FLeftMargin then
  begin
    FLeftMargin := value;
    Paint;
  end;
end;

procedure TrmGraph.SetRightMargin(value: integer);
begin
  if value <> FRightMargin then
  begin
    FRightMargin := value;
    Paint;
  end;
end;

procedure TrmGraph.SetTopMargin(value: integer);
begin
  if value <> FTopMargin then
  begin
    FTopMargin := value;
    Paint;
  end;
end;

procedure TrmGraph.SetBottomMargin(value: integer);
begin
  if value <> FBottomMargin then
  begin
    FBottomMargin := value;
    Paint;
  end;
end;

procedure TrmGraph.SetHorzMinVal(value: single);
begin
  if value <> FHorzMinVal then
  begin
    FHorzMinVal := value;
    Paint;
  end;
end;

procedure TrmGraph.SetHorzMaxVal(value: single);
begin
  if value <> FHorzMaxVal then
  begin
    FHorzMaxVal := value;
    Paint;
  end;
end;

procedure TrmGraph.SetHorzUnit(value: string);
begin
  if value <> FHorzUnit then
  begin
    FHorzUnit := value;
    Paint;
  end;
end;

procedure TrmGraph.SetHorzDecNum(value: integer);
begin
  if value <> FHorzDecNum then
  begin
    FHorzDecNum := value;
    Paint;
  end;
end;

procedure TrmGraph.SetHorzDiv(value: integer);
begin
  if value <> FHorzDiv then
  begin
    FHorzDiv := value;
    Paint;
  end;
end;

procedure TrmGraph.SetVertMinVal(value: single);
begin
  if value <> FVertMinVal then
  begin
    FVertMinVal := value;
    Paint;
  end;
end;

procedure TrmGraph.SetVertMaxVal(value: single);
begin
  if value <> FVertMaxVal then
  begin
    FVertMaxVal := value;
    Paint;
  end;
end;

procedure TrmGraph.SetVertUnit(value: string);
begin
  if value <> FVertUnit then
  begin
    FVertUnit := value;
    Paint;
  end;
end;

procedure TrmGraph.SetVertDecNum(value: integer);
begin
  if value <> FVertDecNum then
  begin
    FVertDecNum := value;
    Paint;
  end;
end;

procedure TrmGraph.SetVertDiv(value: integer);
begin
  if value <> FVertDiv then
  begin
    FVertDiv := value;
    Paint;
  end;
end;

procedure TrmGraph.SetScaleText(value: TScaleText);
begin
  if value <> FScaleText then
  begin
    FScaleText := value;
    Paint;
  end;
end;

procedure TrmGraph.SetTraces(value: TTraces);
begin
  if value <> FTraces then
  begin
    FTraces := value;
    Paint;
  end;
end;

procedure TrmGraph.SetTextColor(value: TColor);
begin
  if value <> FTextColor then
  begin
    FTextColor := value;
    Paint;
  end;
end;

procedure TrmGraph.SetTextSize(value: integer);
begin
  if value <> FTextSize then
  begin
    FTextSize := value;
    Paint;
  end;
end;

procedure TrmGraph.SetMaxItems(value: integer);
var
  i: integer;
begin
  if value <> FMaxItems then
  begin
    FMaxItems := value;
    if (values.Count > FMaxItems) and (FMaxItems > 0) then
      for i := 1 To (values.Count - FMaxItems) do
        values.Delete(0);
    Paint;
  end;
end;

procedure TrmGraph.Clear;
begin
  values.clear;
  Paint;
end;

function TrmGraph.AddValues(s: string; refresh: boolean): integer;
var
  i: integer;
begin
  values.add(s);
  if (values.Count > FMaxItems) and (FMaxItems > 0) then
    for i := 1 To (values.Count - FMaxItems) do
      values.Delete(0);
  result := values.count;
  if refresh then Paint;
end;

function TrmGraph.DeleteValues(i: integer; refresh: boolean): integer;
begin
  if i > values.Count - 1 then exit;
  values.delete(i);
  result := values.count;
  if refresh then Paint;
end;


end.




